package com.dsic.gj_erp.service.jcsj.impl;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.EmSbwxjh;
import com.dsic.gj_erp.bean.request.EmSbwxjhBean;
import com.dsic.gj_erp.mapper.jcsj.EmSbwxjhMapper;
import com.dsic.gj_erp.service.jcsj.EmSbwxjhService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@Service
public class EmSbwxjhServiceImpl extends ServiceImpl<EmSbwxjhMapper, EmSbwxjh> implements EmSbwxjhService {
    @Resource
    EmSbwxjhMapper emSbwxjhMapper;
//    @Resource
//    EmSbwxjhRepository emSbwxjhRepository;

    @Override
    public List<EmSbwxjh> getList(EmSbwxjhBean emSbwxjhBean) {
        QueryWrapper<EmSbwxjh> queryWrapper=new QueryWrapper<>();
        String sbbh=emSbwxjhBean.getSbbh();
        String beginTime=emSbwxjhBean.getBeginTime();
        String endTime=emSbwxjhBean.getEndTime();
        String szcs=emSbwxjhBean.getSzcs();
        if(StringUtils.isNotEmpty(sbbh)){
            queryWrapper.eq("SBBH",sbbh);
        }
        if(StringUtils.isNotEmpty(beginTime)){
            queryWrapper.ge("kssj_jh",beginTime);
        }
        if(StringUtils.isNotEmpty(endTime)){
            queryWrapper.le("jssj_jh",endTime);
        }
        if(StringUtils.isNotEmpty(szcs)){
            queryWrapper.eq("SZCS",szcs);
        }
        List<EmSbwxjh> emSbjbbs=emSbwxjhMapper.selectList(queryWrapper);
        return emSbjbbs;
    }

    @Override
    public void save(List<EmSbwxjh> emSbwxjhs, HttpServletRequest request) {
        String yhms=(String) request.getAttribute("yhdm");
        emSbwxjhs.forEach(emSbjbb -> {
            if (StringUtils.isNotEmpty(emSbjbb.getSbbh())){
                emSbjbb.setFzr(yhms);
               // emSbwxjhMapper.insert(emSbjbb);
            }
        });
        saveBatch(emSbwxjhs);
    }

    @Override
    public void update(List<EmSbwxjh> emSbwxjhs) {
     //   emSbwxjhRepository.saveAll(emSbwxjhs);
        updateBatchById(emSbwxjhs);
    }

    @Override
    public void delete(List<EmSbwxjh> emSbwxjhs) {
        List<String > idList=emSbwxjhs.stream().map(EmSbwxjh::getId).collect(Collectors.toList());
        emSbwxjhMapper.deleteBatchIds(idList);
        //emSbwxjhRepository.deleteAll(emSbwxjhs);
    }
}
